## cvc4-1.8-3.src.tar.gz

=== src/bindings/CMakeLists.txt ===
if(NOT ENABLE_SHARED)
  message(FATAL_ERROR "Can't build language bindings for static CVC4 build.")
endif()

find_package(SWIG 3.0.0 REQUIRED)
if(POLICY CMP0078)
  cmake_policy(SET CMP0078 OLD)
endif()
if(POLICY CMP0086)
  cmake_policy(SET CMP0086 OLD)
endif()

if(USE_PYTHON3 AND (SWIG_VERSION VERSION_EQUAL 3.0.8))
  message(FATAL_ERROR
    "\nSWIG ${SWIG_VERSION} is not supported for python3 bindings because of the following bug: https://github.com/swig/swig/issues/588
Please downgrade to 3.0.0-3.0.7 or upgrade.")
endif()

include(${SWIG_USE_FILE})

set(CVC4_SWIG_INTERFACE ${PROJECT_SOURCE_DIR}/src/cvc4.i)

set_property(SOURCE ${CVC4_SWIG_INTERFACE} PROPERTY CPLUSPLUS ON)

include_directories(
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/include
    ${CMAKE_BINARY_DIR}/src)

if(BUILD_SWIG_BINDINGS_JAVA)
  add_subdirectory(java)
endif()
if(BUILD_SWIG_BINDINGS_PYTHON)
  add_subdirectory(python)
endif()

=== src/api/python/CMakeLists.txt ===
if(POLICY CMP0057)
  # For cmake >= 3.3 this policy changed the behavior of IN_LIST
  # if the policy exists, we use the NEW behavior
  cmake_policy(SET CMP0057 NEW)
endif()

find_package(PythonExtensions REQUIRED)
find_package(Cython 0.29 REQUIRED)

include_directories(${PYTHON_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_LIST_DIR})         # cvc4kinds.pxd
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/include)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
# TEMP: Only needed while expr/kind.h is public in the C++ api
include_directories("${CMAKE_BINARY_DIR}/src/")

# Generate cvc4kinds.{pxd,pyx}
add_custom_target(
  gen-pycvc4-kinds
  ALL
  COMMAND
    "${PYTHON_EXECUTABLE}"
    "${CMAKE_CURRENT_LIST_DIR}/genkinds.py"
    --kinds-header "${PROJECT_SOURCE_DIR}/src/api/cvc4cppkind.h"
    --kinds-file-prefix "${CMAKE_CURRENT_BINARY_DIR}/cvc4kinds"
  DEPENDS
    genkinds.py
  COMMENT
    "Generate cvc4kinds.{pxd,pyx}"
)

add_cython_target(pycvc4 CXX)

add_library(pycvc4
            MODULE
            ${pycvc4})

target_link_libraries(pycvc4 cvc4 ${PYTHON_LIBRARIES})

python_extension_module(pycvc4)

# Installation based on https://bloerg.net/2012/11/10/cmake-and-distutils.html
# Create a wrapper python directory and generate a distutils setup.py file
configure_file(setup.py.in setup.py)
set(PYCVC4_MODULE "${CMAKE_CURRENT_BINARY_DIR}/pycvc4")
file(MAKE_DIRECTORY "${PYCVC4_MODULE}")
file(WRITE ${PYCVC4_MODULE}/__init__.py
"import sys
from .pycvc4 import *
# fake a submodule for dotted imports, e.g. from pycvc4.kinds import *
sys.modules['%s.%s'%(__name__, kinds.__name__)] = kinds")

set(PYCVC4_LOC "${PYCVC4_MODULE}/$<TARGET_FILE_NAME:pycvc4>")
add_custom_command(TARGET pycvc4 POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E rename $<TARGET_FILE:pycvc4> ${PYCVC4_LOC}
)

# figure out if we're in a virtualenv
execute_process(OUTPUT_VARIABLE IN_VIRTUALENV
  COMMAND
  "${PYTHON_EXECUTABLE}"
  -c
  "from __future__ import print_function; import os;
print('YES' if 'VIRTUAL_ENV' in os.environ else 'NO', end='')")

set(INSTALL_CMD "${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py install")
# if we're in a virtualenv, we install it in the virtualenv lib location
if ("${IN_VIRTUALENV}" STREQUAL "NO")
  set(INSTALL_CMD "${INSTALL_CMD} --prefix=${CMAKE_INSTALL_PREFIX}")
endif()

message("Python bindings install command: ${INSTALL_CMD}")

install(CODE "execute_process(COMMAND ${INSTALL_CMD})"  FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Philipp Sieweck

pkgname=cvc4
_pkgname=cvc5
pkgver=1.8
pkgrel=3
pkgdesc="An automatic theorem prover"
arch=('x86_64')
url="https://cvc5.github.io/"
depends=('libantlr3c' 'cln')
makedepends=('cmake' 'java-runtime' 'python-toml')
optdepends=('readline: for an improved interaction support')
license=('GPL' 'BSD' 'MIT' 'custom:HPND')
source=("https://github.com/cvc5/cvc5/archive/$pkgver/$_pkgname-$pkgver.tar.gz"
        "https://www.antlr3.org/download/antlr-3.4-complete.jar"
        cvc4-fix-headers.patch
        cvc4-gcc7.patch)
noextract=('antlr-3.4-complete.jar')
sha512sums=('ae7be9856c22f430bffdf686dca3351372537a3887ccb36cc739312fd175686f76bc3783882d0c03c69cbbf039dcb4f561aa53a539dcb885bab981c1dbdd8c41'
            '04be4dfba3a21f3ab9d9e439a64958bd8e844a9f151b798383bd9e0dd6ebc416783ae7cb1d1dbb27fb7288ab9756b13b8338cdb8ceb41a10949c852ad45ab1f2'
            'f6a60c2b95c348f7e8abffc79befef0910ff962143b0b5f89f9b3c9798fff575a9bfc71ae8271c9e56e2f5e400539879b440df23aef7c23664eaec9cd5d6fe10'
            'ff5d60141f97394b625c336614afa5a6429d775bed12e277ad1bc64b84f865a958fb075185fb9726ea8ca443b55aedb1a8d114840f016ed8e639dbcf77aa3783')

prepare() {
  cd $_pkgname-$pkgver

  patch -p1 -i ../cvc4-fix-headers.patch
  patch -p1 -i ../cvc4-gcc7.patch

  mkdir -p antlr-3.4/bin
  tee antlr-3.4/bin/antlr3 <<EOF
#!/bin/bash
export CLASSPATH=$srcdir/antlr-3.4-complete.jar:\$CLASSPATH
exec java org.antlr.Tool "\$@"
EOF
  chmod a+x antlr-3.4/bin/antlr3
}

build() {
  cd $_pkgname-$pkgver
  export PATH="$PATH:$PWD/antlr-3.4/bin"
  ./configure.sh --prefix=/usr --cln --gpl
  cd build
  make
}

check() {
  cd $_pkgname-$pkgver
  make -C build check
}

package() {
  cd $_pkgname-$pkgver
  make -C build DESTDIR="$pkgdir/" install
  install -Dm644 "$srcdir/$_pkgname-$pkgver/COPYING" "$pkgdir"/usr/share/licenses/$pkgname/LICENSE
}
